.386
.MODEL FLAT,STDCALL
option casemap:none

; 
;Include files
include Just a Bitmap.inc

; 

.CODE
; 

START:
      invoke GetModuleHandle,NULL
      mov hInstance,eax

      invoke GetCommandLine
      mov CommandLine,eax

      invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT

      invoke ExitProcess,eax
; ..............................................................................................

WinMain proc hInst:HINSTANCE,PrevhInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
; ..............................................................................................

;Declaring Local Variables

      LOCAL wc:WNDCLASSEX
      LOCAL msg:MSG
      LOCAL hwnd:HWND
      LOCAL rect:RECT
      
      LOCAL Ww:DWORD
      LOCAL Wh:DWORD
      LOCAL Wx:DWORD
      LOCAL Wy:DWORD

            mov wc.cbSize,SIZEOF WNDCLASSEX
            mov wc.style,CS_HREDRAW or CS_VREDRAW
            mov wc.lpfnWndProc,OFFSET WndProc
            mov wc.cbClsExtra,NULL
            mov wc.cbWndExtra,NULL

            push hInstance
            pop wc.hInstance

            invoke LoadBitmap,hInstance,ADDR Background
            invoke CreatePatternBrush,eax
            mov wc.hbrBackground,eax
            mov wc.lpszMenuName,NULL
            mov wc.lpszClassName,OFFSET ClassName

            invoke LoadIcon,NULL,IDI_APPLICATION
            mov wc.hIcon,eax
            mov wc.hIconSm,eax

            invoke LoadCursor,NULL,IDC_ARROW 
            mov wc.hCursor,eax

      invoke RegisterClassEx,ADDR wc

; ..............................................................................................

;Creating Window and Showing it on Desktop

mov Ww,570
invoke GetSystemMetrics,SM_CXSCREEN
invoke WndPos,Ww,eax
mov Wx,eax

mov Wh,100
invoke GetSystemMetrics,SM_CYSCREEN
invoke WndPos,Wh,eax
mov Wy,eax
invoke CreateWindowEx,NULL,\
                     ADDR ClassName,\
                     ADDR AppName,\
                     WS_POPUP,\
                     Wx,\
                     Wy,\
                     Ww,\
                     Wh,\
                     NULL,\
                     NULL,\
                     hInst,\
                     NULL
mov hwnd,eax

invoke ShowWindow,hwnd,SW_SHOWNORMAL
invoke UpdateWindow,hwnd

; 

              
            .WHILE TRUE
                   invoke GetMessage,ADDR msg,NULL,0,0
                   .Break .IF (!eax)
                   invoke TranslateMessage,ADDR msg
                   invoke DispatchMessage,ADDR msg
             .ENDW
             mov eax,msg.wParam
             ret
             WinMain endp
; ..............................................................................................
WndProc proc hWnd:HWND,uMsg:UINT,wParam,lParam
; ..............................................................................................

            .IF uMsg==WM_DESTROY
                    invoke PostQuitMessage,NULL

            .ELSEIF uMsg==WM_CREATE
            	    invoke CreateWindowEx,WS_EX_CLIENTEDGE,chr$("BUTTON"),NULL,BS_BITMAP or WS_CHILD or WS_VISIBLE,10,10,80,60,hWnd,1000,hInstance,NULL
            	    mov hButton,eax
            	    invoke LoadBitmap,hInstance,ADDR Button
            	    invoke SendMessage,hButton,BM_SETIMAGE,IMAGE_BITMAP,eax

            .ELSEIF uMsg==WM_RBUTTONUP
            	    invoke SendMessage,hWnd,WM_DESTROY,0,0

            .ELSEIF uMsg==WM_LBUTTONDOWN
            	    mov eax,wParam

            .ELSEIF uMsg==WM_COMMAND
                   mov eax,wParam
                   .if ax==1000
                       invoke MessageBox,hWnd,ADDR Message,ADDR AppName,MB_OK
                   .endif
            .ELSE
                    invoke DefWindowProc,hWnd,uMsg,wParam,lParam
                    ret
            .ENDIF
                    xor eax,eax
                    ret

WndProc endp

WndPos proc Wc:DWORD,Sc:DWORD

	shr Wc,1
	shr Sc,1
	mov eax,Wc
	sub Sc,eax 
	return Sc

WndPos endp

END START       